﻿
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

// Packages fÃ¼r Opendialog
import javax.swing.JFileChooser;

import java.io.*;

import java.awt.FontMetrics.*;


import javax.swing.plaf.metal.*;  // look and Feel

public class HexEditor extends JFrame implements ActionListener, IInsertFile {
  private final int FONTSIZE = 14;
  
  private JMenuBar menuBar1;  // MenueContainer
  private JMenu mainFile;     
  private JMenuItem mnOpen;   
  private JMenuItem mnClose;  

  private JMenu mainEdit;     
  private JMenuItem mnDeleteTab; 

  private JMenu mainExport;
  private JMenuItem mnExport2Biff; 

  private JMenu mainView;
  private JMenuItem mnSearchDialog; 
  
  private JMenu mainLook_Feel;
  private JMenuItem mnLook_Feel_Windows;
  private JMenuItem mnLook_Feel_Motif;
  private JMenuItem mnLook_Feel_Metal;
  private JMenuItem mnLook_Feel_Nimbus;
   
  
  
  private JTabbedPane jTabbedPane1;

  private JComboBox comboFont;
  
    public HexEditor() {
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
    setMenus();
  }

  private void setGUI() {
    setSize(800, 430);
    setTitle("Hexeditor");

    this.getContentPane().setLayout( new BorderLayout() );
    jTabbedPane1 = new JTabbedPane();
    jTabbedPane1.setFont( new Font("Arial", Font.BOLD,18));

   
    //jpanelGrf.setBackground(Color.red);
    this.getContentPane().add( jTabbedPane1, BorderLayout.CENTER);

    JPanel jpanelTop= new JPanel();
    jpanelTop.setLayout( new GridBagLayout() );
    JLabel label1 = new JLabel("Fontgröße: ");

    comboFont = new JComboBox();
    for (int i=8; i<36; i+=2) {      
      comboFont.addItem( Integer.toString(i) );
    }
    label1.setFont( new Font("Arial", Font.BOLD,FONTSIZE));
    comboFont.setFont( new Font("Arial", Font.BOLD,FONTSIZE));

    jpanelTop.add(label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(0,0,20,20), 0, 0));

    jpanelTop.add(comboFont,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(0,0,20,20), 0, 0));

    comboFont.setSelectedIndex( 3 );
    comboFont.addActionListener(
     new java.awt.event.ActionListener() {
       @Override
      public void actionPerformed(ActionEvent e) {
        comboFont_click();
      }
    });

    this.getContentPane().add( jpanelTop, BorderLayout.NORTH);
  } // setGUI

    // setzt die Menues
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    mainFile = new JMenu("Datei");
    mnOpen = new JMenuItem("Öffnen");
    mnClose = new JMenuItem("Schließen");


     mnOpen.addActionListener( this );
     mnClose.addActionListener( this );
    
      // Event definieren
      // Short Key definieren  STRG+O
    mnOpen.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
    mainFile.add(mnOpen);
    mainFile.addSeparator();

    mainFile.add(mnClose);

      // HauptmenÃ¼ FILE in den MenÃ¼Bar einfÃ¼gen
    menuBar1.add(mainFile);

    mainEdit = new  JMenu("Bearbeiten");
    mnDeleteTab = new JMenuItem("Löschen des aktuellen Registers");

    
    mainEdit.add(mnDeleteTab);
    menuBar1.add(mainEdit);
    mnDeleteTab.addActionListener( this );
    

    mainExport = new JMenu("Export");
    mnExport2Biff = new JMenuItem("Export 2 Excel (BIFF)") ;
    mainExport.add(mnExport2Biff);
    menuBar1.add(mainExport);
    mnExport2Biff.addActionListener( this );
    
    
  
    mainView = new JMenu("Ansicht");
    mnSearchDialog = new JMenuItem("Auswahldialog") ;
    mainView.add(mnSearchDialog);
    menuBar1.add(mainView);
    mnSearchDialog.addActionListener( this );
    
    
    mainLook_Feel = new JMenu("Look & Feel");
    mnLook_Feel_Windows = new JMenuItem("Windows");
    mainLook_Feel.add(mnLook_Feel_Windows);


    mnLook_Feel_Motif = new JMenuItem("Motif");

    mainLook_Feel.add(mnLook_Feel_Motif);

    mnLook_Feel_Metal = new JMenuItem("Metal");

    mainLook_Feel.add(mnLook_Feel_Metal);

    mnLook_Feel_Nimbus = new JMenuItem("Nimbus");
    
    mainLook_Feel.add(mnLook_Feel_Nimbus);
    menuBar1.add(mainLook_Feel);
    
    mnLook_Feel_Windows.addActionListener( this );
    mnLook_Feel_Motif.addActionListener( this );
    mnLook_Feel_Metal.addActionListener( this );
    mnLook_Feel_Nimbus.addActionListener( this );
    
    this.setJMenuBar(menuBar1);
    
    for (int i=0; i<menuBar1.getMenuCount(); i++) {
      JMenu main = menuBar1.getMenu(i);
      main.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );      
      JMenuItem mn;
      for (int j=0; j<main.getItemCount(); j++) {
        mn = main.getItem(j);
        // Abfrage auf Separator, sonst Absturz
        if ( mn instanceof JMenuItem )
          mn.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
      }
    }
    
  } // setMenus


    public void actionPerformed(ActionEvent e) {
         JMenuItem mn = (JMenuItem) e.getSource();
         if (mn.equals(mnOpen)) {
             MnOpen_Click();
             return;
         }
         if (mn.equals(mnClose)) {
            this.dispose();
             return;
         }
         if (mn.equals(mnDeleteTab)) {
           DeleteTab();
             return;
         }
         
         if (mn.equals(mnLook_Feel_Windows) ){
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
         }
         if (mn.equals(mnExport2Biff)) {
                Export2BIFF();
                return;
         
         }
         if (mn.equals(mnSearchDialog)) {
                SearchDialog();
                return;
         
         }
         
         if (mn.equals(mnLook_Feel_Motif)) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
         }
         if (mn.equals(mnLook_Feel_Metal)) {
            try {
                UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
         }
         if (mn.equals(mnLook_Feel_Nimbus)) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
         }
         

     }

   private void comboFont_click() {
     int i = comboFont.getSelectedIndex();
     if (i>=0) {
      System.out.println(8+i+i);      
      int n = jTabbedPane1.getTabCount();
      for (int j=0; j<n; j++) {
          HexPanel hexpanel = (HexPanel) jTabbedPane1.getComponentAt(j);  // getTabComponentAt(j);
          hexpanel.setFontSize(8+i+i);
      }
      //jTabbedPane1.getSelectedIndex();
          // jTabbedPane1.removeTabAt(i);
     // hexpanel.setFontSize(8+i+i);
     // hexpanel.updateUI();
     }
   }
   
   private void SearchDialog() {
       SelectView frame = new SelectView(this);
       frame.setVisible(true);  // JDialog waere modal
   }
   
   private void Export2BIFF() {
      int i = jTabbedPane1.getSelectedIndex();  // -1  bedeutet  kein Register ausgewaehlt
      if (i>=0) {
            JFileChooser jFileChooser1 = new JFileChooser();
            String sFilename;
            // setzen der Optionen
            jFileChooser1.setMultiSelectionEnabled(false);
            jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );

            // Aufruf des Dialogfensters
            if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
                // holen des Dateinamens
              sFilename = jFileChooser1.getSelectedFile().getPath();
              HexPanel hexpanel = (HexPanel) jTabbedPane1.getComponentAt(i); 
              hexpanel.Export2BIFF(sFilename);
            }
      }

   }

   
  private void DeleteTab() {
      int i = jTabbedPane1.getSelectedIndex();  // -1  bedeutet  kein Register ausgewaehlt
      if (i>=0) {
          jTabbedPane1.removeTabAt(i);
      }
  }
   

  void MnOpen_Click() {
   JFileChooser jFileChooser1 = new JFileChooser();
   String sFilename;
     // setzen der Optionen
   jFileChooser1.setMultiSelectionEnabled(false);
   jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );

      // Aufruf des Dialogfensters
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
        // holen des Dateinamens
      sFilename = jFileChooser1.getSelectedFile().getPath();
      insertFile(sFilename);
    }
  }  // MnOpen
  
  
   public void insertFile(String sFilename) {
      HexPanel hexpanel = new HexPanel(sFilename);      
      hexpanel.updateUI();
      jTabbedPane1.add( Basis.getFileNameExt(sFilename) ,  hexpanel);      
      hexpanel.loadFile(sFilename);             
      jTabbedPane1.setSelectedIndex(  jTabbedPane1.getTabCount()-1   );
   }


    public static void main(String[] args) {
        HexEditor frame = new HexEditor();
        frame.setVisible(true);
    }
}
